#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>

#define closesocket close
#define PROTOPORT 5193
extern int errno;
char localhost[] = "localhost";

main (int argc, char *argv[])
{
	struct hostent *ptrh;
	struct protoent *ptrp;
	struct sockaddr_in sad;
	int sd;
	int port;
	char *host;
	int n,i;
	int a[3], vysl[1];
	
	/*priprav adresu servera*/
	memset((char *)&sad,0,sizeof(sad));
	sad.sin_family = AF_INET;
	
	if (argc > 2) 
		port = atoi(argv[2]);
	else 
		port = PROTOPORT;

	if (port > 0) sad.sin_port = htons ((u_short)port);
	else 
	{
		fprintf(stderr,"Nespravne cislo portu %s\n", argv[2]);
		exit(1);
	}

	if (argc > 1) 
		host = argv[1];
	else 
		host = localhost;

	ptrh = gethostbyname(host);
	if (((char *)ptrh)== NULL)
	{
		fprintf(stderr,"Nespravny host: %s\n",host);
		exit(1);
	}

	/*nastav adresu sad podla ptrh*/
	memcpy(&sad.sin_addr, ptrh->h_addr, ptrh->h_length);

	/*mapuj TCP nazov protokolu na cislo protokolu*/
	if (((int)(ptrp = getprotobyname("tcp"))) == 0)
	{
		fprintf(stderr,"Chyba mapovania\"tcp\" na cislo protokol\n");
		exit(1);
	}

	/*vytvor soket komunikacie a vrat descrtiptor*/
	sd = socket(PF_INET, SOCK_STREAM, ptrp->p_proto);
	if (sd < 0)
	{
		fprintf(stderr, "Chyba vytvarania soketu\n");
		exit(1);
	}

	/*pripoj sa*/
	if (connect(sd, (struct sockaddr *)&sad, sizeof(sad)) < 0)
	{
		fprintf(stderr,"Chyba vytvarania spojenia\n");
		exit(1);
	}

	for (i=0; i<3; i++)
	{
		fprintf(stderr,"Klient: Zadaj cislo: ");
		scanf("%i",&a[i]);
		getchar();
	}

	printf ("Klient: Cau server! Tu mas data!\n");

	for (i=0; i<3; i++)
	{
		fprintf(stderr, "Klient: %i\n",a[i]);
	}

	fprintf(stderr,"Klient: Posielam....\n");
	send(sd, a, sizeof(a), 0);
	fprintf(stderr,"Klient: Cakam....\n");

	sleep(1);


	/*citaj spravu zo soketu*/
	n = recv(sd, vysl, sizeof(vysl), 0);//pocet dat ktore sa nacitali
	while (n > 0)
	{
		printf(stderr, "KLIENT: Vysledok %i", vysl[0]);
		n = -1;
	}

	/*zatvor soket*/
	closesocket(sd);
	exit(0);
}
