#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <string.h>

void *funkcia_vlakna (void *arg);
pthread_mutex_t mutex; //chrani premenne zdielane_text a ydielane_koniec

int zdielane_pole[3];
int zdielana_koniec = 0,prepni=0,i;


int main () 
{
	int stav;
	pthread_t a_thread;
	void *vysledok_vlakna;
	
        for (i=0; i<3; i++)
        {
		zdielane_pole[i]=0;
	}

	stav = pthread_mutex_init(&mutex, NULL);
	if (stav != 0) 
	{
		perror ("chyba vytvarania mutexu");
		exit (EXIT_FAILURE);
	}
	stav=pthread_create (&a_thread,NULL,funkcia_vlakna,NULL);
	if (stav != 0) 
	{
		perror ("chyba vytvarania vlakna !");
		exit (EXIT_FAILURE);
	}
	pthread_mutex_lock(&mutex); 
	/*zamkni mutex -> je mozne pracovat so zdielanymi premennymi */
	while (!zdielana_koniec) 
	{	
		for (i=0; i<3; i++)
		{
			printf("Zadaj prvok: \n");
			fflush(stdout);
			scanf("%i",&zdielane_pole[i]);
			fflush(stdin);
			getchar();
		}
		printf("\n\n");
       		pthread_mutex_unlock(&mutex); 
		/*odomkni mutex ->zdielane premenne su volne */
        	sleep(1);
		while (1)
		{
        		pthread_mutex_lock(&mutex);
        		if (prepni == 1) 
			{   
			/*zisti ci uz je premena prepni rovna 1*/
        			pthread_mutex_unlock(&mutex); 
				/* nie -> cakaj dalej*/
        			sleep(1);
        		} else {
        			break;   
		    /* ano -> opakuj hlavny cyklus; nacitaj dalsie pole*/
        		}
        	}	
	}
	
	pthread_mutex_unlock(&mutex);
	printf("\ncakam na koniec vlakna...\n");
	stav = pthread_join(a_thread,&vysledok_vlakna);
	if (stav!=0)
	{
		perror ("chyba pripajanie k vlaknu !\n");
		exit (EXIT_FAILURE);
	}
	printf ("vlakno ukoncene\n");
	pthread_mutex_destroy(&mutex);
	exit (EXIT_SUCCESS);
}

void *funkcia_vlakna (void * arg) 
{	
	int j,k,m=0;
	sleep (1);
	pthread_mutex_lock(&mutex);
    	while(1) 
	{
		for (j=0; j<3; j++)
		{
			for (k=0; k<3-1; k++)
			{
				if (zdielane_pole[k] > zdielane_pole[k+1])
				{
					m=zdielane_pole[k];
					zdielane_pole[k]=zdielane_pole[k+1];
					zdielane_pole[k+1]=m;
				}
			}	
		}
		
		printf("Pole: ");
		fflush(stdout);
    		for (i=0; i<3; i++)
		{
			printf("%i\n",zdielane_pole[i]);
			fflush(stdout);
		}
		printf("================================================\n");
		for (i=0; i<3; i++)
		{
			zdielane_pole[i]=0;
		}
		prepni = 0;
    		pthread_mutex_unlock(&mutex);
    		sleep (1);
    		pthread_mutex_lock (&mutex);
    		while (prepni == 0) 
		{
			prepni = 1;
    			pthread_mutex_unlock(&mutex);
    			sleep (1);
    			pthread_mutex_lock (&mutex);
    		}	
    	}	
    	zdielana_koniec = 1;
   	pthread_mutex_unlock(&mutex);
    	pthread_exit (NULL);
    
}		
