#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>

void *thread_function(void *arg);
sem_t bin_sem;

#define WORK_SIZE 1024
char work_area[WORK_SIZE];
int zdielane_pole[3],i;

int main()
{
	int res;
	pthread_t a_thread;
	void *thread_result;
	
	res = sem_init(&bin_sem, 0, 0);
	if (res !=0)
	{
		perror("Chyba vytvarania semaforu");
		exit(EXIT_FAILURE);
	}
	res = pthread_create (&a_thread, NULL, thread_function, NULL);
	if (res !=0)
	{
		perror("Chyba vytvarania vlakna");
		exit(EXIT_FAILURE);
	}
	
	for (i=0; i<3; i++)
        {
		zdielane_pole[i]=0;
	}
	
	printf("Zadaj text, Zadaj 'end' pre koniec\n");
	while(strncmp("end",work_area, 3) !=0)
	{
		fgets(work_area, WORK_SIZE, stdin);
		//printf("\n");
		if (strncmp("end",work_area,3) !=0)
		{
		for (i=0; i<3; i++)
		{
			printf("Zadaj prvok: \n");
			fflush(stdout);
			scanf("%i",&zdielane_pole[i]);
			fflush(stdin);
			getchar();
		}
		}
		sem_post(&bin_sem);
	}
	printf("\nCakam na koniec vlakna....\n");
	res = pthread_join(a_thread, &thread_result);
	if (res !=0)
	{
		perror("Chyba thread_join");
		exit(EXIT_FAILURE);
	}
	printf("Vlakno joined\n");
	sem_destroy(&bin_sem);
	exit(EXIT_FAILURE);
}

void *thread_function(void *arg)
{
	int j,k,m=0;
	sem_wait(&bin_sem);
	while(strncmp("end", work_area, 3) !=0)
	{
		for (j=0; j<3; j++)
		{
			for (k=0; k<3-1; k++)
			{
			      if (zdielane_pole[k] > zdielane_pole[k+1])
				{
				    m=zdielane_pole[k];
				    zdielane_pole[k]=zdielane_pole[k+1];
				    zdielane_pole[k+1]=m;
				}
			}	
		}
		
		printf("Pole: ");
		fflush(stdout);
    		for (i=0; i<3; i++)
		{
			printf("%i, ",zdielane_pole[i]);
			fflush(stdout);
		}
	        printf("\n==============================================\n");
		printf("Zadaj text: ");
		fflush(stdout);
		for (i=0; i<3; i++)
		{
			zdielane_pole[i]=0;
		}
		sem_wait(&bin_sem);
	}
	pthread_exit(NULL);
}
